﻿AMPFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDB-2.0");

AMPFu.title = "Answering Machine Plus";
AMPFu.category = "Chat/Communication";
AMPFu.cannotDetachTooltip  = true;
AMPFu.tooltipHiddenWhenEmpty  = true;

local COLOR_TELL = "ff7fff"
local COLOR_SYSTEM = "ffff00"
local COLOR_WHITE = "ffffff"

function AMPFu:OnInitialize()
	self.cannotHideText = false
	self.cannotAttachToMinimap = true
	self.hasNoColor = false
	self.hasIcon = true
	self:SetIcon(true)
	self:RegisterDB("AMPFuDB")
	self:RegisterDefaults('profile', {
		showText = true,
		showIcon = true
	})
end

function AMPFu:IsMSGPersist()
    return AMPConfig.Msg_Persist
end

function AMPFu:ToggleMSGPersist()
    AMP_ToggleMsgPersist()
    self:Update()
end

function AMPFu:IsAMPFrame()
    return AMPConfig.AMP_Frame
end

function AMPFu:ToggleAMPFrame()
    AMP_ToggleAMPFrame()
    self:Update()
end

function AMPFu:IsRecordAFK()
    return AMPConfig.rec_AFK
end

function AMPFu:ToggleRecordAFK()
    AMP_ToggleRecAFK()
    self:Update()
end

function AMPFu:IsAutoClear()
    return AMPConfig.autoclear
end

function AMPFu:ToggleAutoClear()
    AMP_ToggleAutoClear()
    self:Update()
end

function AMPFu:IsRecordDND()
    return AMPConfig.rec_DND
end

function AMPFu:ToggleRecordDND()
    AMP_ToggleRecDND()
    self:Update()
end

function AMPFu:IsAutoReply()
    return AMPConfig.autoreply_COMBAT
end

function AMPFu:ToggleAutoReply()
    AMP_ToggleAutoReplyInCombat()
    self:Update()
end

function AMPFu:IsRecordAuction()
    return AMPConfig.rec_AUCTION
end

function AMPFu:ToggleRecordAuction()
    AMP_ToggleRecAUCTION()
    self:Update()
end

function AMPFu:IsCheckIgnore()
    return AMPConfig.chk_Ignore
end

function AMPFu:ToggleCheckIgnore()
    AMP_ToggleChkIgnore()
    self:Update()
end

-- using an AceOptions data table
AMPFu.OnMenuRequest = {
    type = 'group',
    args = {
        value1 = {
            type = "toggle",
            name = AMP_REC_AFK_MENU,
            desc = AMP_FUBAR_REC_AFK_DESC,
            get = "IsRecordAFK",
            set = "ToggleRecordAFK",
        },
        value2 = {
            type = "toggle",
            name = AMP_REC_DND_MENU,
            desc = AMP_FUBAR_REC_DND_DESC,
            get = "IsRecordDND",
            set = "ToggleRecordDND",
        },
        value3 = {
            type = "toggle",
            name = AMP_REC_AUCTION_MENU,
            desc = AMP_FUBAR_REC_AUCTION_DESC,
            get = "IsRecordAuction",
            set = "ToggleRecordAuction",
        },
        value4 = {
            type = "toggle",
            name = AMP_IN_COMBAT_MENU,
            desc = AMP_FUBAR_IN_COMBAT_DESC,
            get = "IsAutoReply",
            set = "ToggleAutoReply",
        },
        value5 = {
            type = "toggle",
            name = AMP_IGNORE_MENU,
            desc = AMP_FUBAR_IGNORE_DESC,
            get = "IsCheckIgnore",
            set = "ToggleCheckIgnore",
        },
        value6 = {
            type = "toggle",
            name = AMP_AUTOCLEAR_MENU,
            desc = AMP_FUBAR_AUTOCLEAR_DESC,
            get = "IsAutoClear",
            set = "ToggleAutoClear",
        },
        value7 = {
            type = "toggle",
            name = AMP_FRAME_MENU,
            desc = AMP_FUBAR_FRAME_DESC,
            get = "IsAMPFrame",
            set = "ToggleAMPFrame",
        },
        value8 = {
            type = "toggle",
            name = AMP_MSG_MENU,
            desc = AMP_FUBAR_MSG_DESC,
            get = "IsMSGPersist",
            set = "ToggleMSGPersist",
        }
    }
}

function AMPFu:OnDataUpdate()
end

function AMPFu:OnTextUpdate()
    	local text
	if self:IsTextColored() then
		text = format("|cff%s%d|r|cff%s/|r|cff%s%d|r", COLOR_TELL, AMP_getMissedTells(),COLOR_WHITE, COLOR_SYSTEM, AMP_getMissedAuctions())
	else
		text = AMP_getMissedTells() .. "/" .. AMP_getMissedAuctions()
	end
	if self:IsTextShown() then
		self:SetText(text)
	end
	if self:IsIconShown() then
		self:ShowIcon()
	else
		self:HideIcon()
	end
end

local tablet = AceLibrary("Tablet-2.0")
function AMPFu:OnTooltipUpdate()
    local cat = tablet:AddCategory(
        'text', "",
        'columns', 1,
        'child_textR', 1,
        'child_textG', 1,
        'child_textB', 0
    )
    
    cat:AddLine(
        'text', AMP_GetTooltipText()
    )
end

function AMPFu:OnClick()
	if (arg1 == "LeftButton") then
		AMP_Retell_Msgs()
	end
end