﻿function TitanPanelAMPButton_OnLoad()

	if not TitanPanelButton_UpdateButton then
		return
	end

	this.registry = {
		id = TITAN_AMP_ID,
		menuText = AMP_MENU,
		version = AMP_VERSION,
		buttonTextFunction = "TitanPanelAMPButton_GetButtonText",
		tooltipTitle = AMP_MENU,
		tooltipTextFunction = "TitanPanelAMPButton_GetTooltipText",
		frequency = TITAN_AMP_FREQUENCY,
		category = TITAN_AMP_CATEGORY,
		icon = "Interface\\AddOns\\AMP\\AMP",
		iconWidth = 16,
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,
			ShowColoredText = TITAN_NIL
		}
	}

end

function TitanPanelAMPButton_OnClick(arg1)
	if (arg1 == "LeftButton") then
		AMP_Retell_Msgs()
	end
end

function TitanPanelAMPButton_GetTooltipText()
	return AMP_GetTooltipText()
end

function TitanPanelAMPButton_GetButtonText(id)
	local ButtonText = ""
	if (TitanGetVar(TITAN_AMP_ID, "ShowColoredText")) then
		ButtonText = TitanUtils_GetColoredText(AMP_getMissedTells(),  ChatTypeInfo["WHISPER"]) .. "/" .. TitanUtils_GetColoredText(AMP_getMissedAuctions(),  ChatTypeInfo["SYSTEM"])
	else
		ButtonText = AMP_getMissedTells() .. "/" .. AMP_getMissedAuctions()
	end
	if (TitanGetVar(TITAN_AMP_ID, "ShowLabelText")) then
		ButtonText = AMP_LABEL .. ButtonText
	end
	return ButtonText
end

function TitanPanelRightClickMenu_PrepareAMPMenu()

	TitanPanelRightClickMenu_AddTitle(AMP_MENU)

	TitanPanelRightClickMenu_AddSpacer()

	info = {}
	info.text = AMP_REC_AFK_MENU
	info.func = AMP_ToggleRecAFK
	info.value = AMP_REC_AFK_MENU
	info.checked = AMPConfig.rec_AFK
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

	info = {}
	info.text = AMP_REC_DND_MENU
	info.func = AMP_ToggleRecDND
	info.value = AMP_REC_DND_MENU
	info.checked = AMPConfig.rec_DND
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

	TitanPanelRightClickMenu_AddSpacer()

	info = {}
	info.text = AMP_REC_AUCTION_MENU
	info.func = AMP_ToggleRecAUCTION
	info.value = AMP_REC_AUCTION_MENU
	info.checked = AMPConfig.rec_AUCTION
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

	info = {}
	info.text = AMP_IN_COMBAT_MENU
	info.func = AMP_ToggleAutoReplyInCombat
	info.value = AMP_IN_COMBAT_MENU
	info.checked = AMPConfig.autoreply_COMBAT
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

	info = {}
	info.text = AMP_IGNORE_MENU
	info.func = AMP_ToggleChkIgnore
	info.value = AMP_IGNORE_MENU
	info.checked = AMPConfig.chk_Ignore
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

	info = {}
	info.text = AMP_AUTOCLEAR_MENU
	info.func = AMP_ToggleAutoClear
	info.value = AMP_AUTOCLEAR_MENU
	info.checked = AMPConfig.autoclear
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

	info = {}
	info.text = AMP_FRAME_MENU
	info.func = AMP_ToggleAMPFrame
	info.value = AMP_FRAME_MENU
	info.checked = AMPConfig.AMP_Frame
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

	info = {}
	info.text = AMP_MSG_MENU
	info.func = AMP_ToggleMsgPersist
	info.value = AMP_MSG_MENU
	info.checked = AMPConfig.Msg_Persist
	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

	TitanPanelRightClickMenu_AddSpacer()

	TitanPanelRightClickMenu_AddToggleIcon(TITAN_AMP_ID)
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_AMP_ID)
	TitanPanelRightClickMenu_AddToggleColoredText(TITAN_AMP_ID)
	
	TitanPanelRightClickMenu_AddSpacer()

	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_AMP_ID, TITAN_PANEL_MENU_FUNC_HIDE)

end
